--[[ The player  document
    (does not need to be a class (since there is only one player)
 ]]--
 player = {
    x = 0, --x position of player
    y= 0, --y position of player
    y_velocity = 0, -- velocity in the y axis
    speed = 300, --player speed
    jetpack_fuel = 0.5, --not an actual jetpack (time in seconds)
                                --longer keypress = higher jump
    jetpack_fuel_max = 0.5, --maximum time for the jump
    on_block = true, --if user is in block
    platform_height = 0, --defines the floor
    image = love.graphics.newImage("hamster.png") 
 }
 
 function player:right(dt)--move right
     if love.keyboard.isDown("right") then--if presses right key
          player.x = player.x + (player.speed * dt)
     end
end

function player:left(dt)--move left
       if love.keyboard.isDown("left") then--if presses left key
          player.x = player.x - (player.speed * dt)
       end
 end
 
 function player:update(dt,gravity)
    if player.jetpack_fuel > 0 -- we can still move upwards
    and love.keyboard.isDown(" ") then -- and we're actually holding space
        player.jetpack_fuel = player.jetpack_fuel - dt -- decrease the fuel meter
        player.y_velocity = player.y_velocity + jump_height * (dt / player.jetpack_fuel_max)
    end
    if player.y_velocity ~= 0 or not(player.on_block) then --if we're in the air
        player.on_block = false --not on a block
        player.y = player.y + player.y_velocity * dt -- dt means we wont move at
        -- different speeds if the game lags
        player.y_velocity = player.y_velocity - gravity * dt --updates 
        if player.y < player.platform_height then -- we hit a platform
            player.y_velocity = 0 
            player.y = 0
            player.jetpack_fuel = player.jetpack_fuel_max 
        end
    end
end
 
 function player:jumpAction()
        if player.y_velocity == 0 then -- if on the ground
            player.y_velocity = jump_height --jump
        end
end